<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'DibLineGraph',
  props: {
    data: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
  },
  mounted() {
    const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
    const children = Array.from(document.querySelectorAll('.progress'));

    if (!mediaQuery.matches) {
      const observer = new IntersectionObserver(this.updateWidth, {
        rootMargin: '0px',
        threshold: 1,
      });
      children.forEach((child) => observer.observe(child));
    } else {
      children.forEach((element) => {
        const width = element.dataset.progress.replace(/\D/g, '');
        element.style.transition = 'none';
        element.style.width = `${width}%`;
      });
    }
  },
  methods: {
    updateWidth(entries, observer) {
      entries.forEach((entry) => {
        if (entry.isIntersecting) {
          const element = entry.target;
          const width = element.dataset.progress.replace(/\D/g, '');
          const { opacity } = element.dataset;
          element.style.width = `${width}%`;
          element.style.opacity = opacity;
          observer.unobserve(element);
        }
      });
    },
  },
});
</script>

<template>
  <div class="graph-wrapper">
    <div>
      <div v-for="graph in data" :key="graph.label" class="graph-container">
        <div class="bar">
          <span
            class="progress"
            :data-progress="graph.number"
            :data-opacity="`${graph.opacity || 1}`"
          />
          <SlpTypography variant="body1" class="value"
            >{{ graph.number }}%</SlpTypography
          >
        </div>
        <SlpTypography variant="body2-bold" tag="p" class="name">{{
          graph.label
        }}</SlpTypography>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.graph-wrapper {
  .graph-block {
    margin-right: 4rem;
  }
  @media (max-width: $breakpoint-lg) {
    margin-bottom: $spacing-32;
    flex-direction: column;
    .graph-block {
      margin-right: 0;
    }
  }
}

.graph-container {
  margin-bottom: $spacing-32;
  .name {
    max-width: 450px;
  }
  .bar {
    width: 100%;
    height: 32px;
    background-color: rgba(238, 231, 253, 0.5);
    display: flex;

    @media (min-width: $breakpoint-lg) {
      min-width: 450px;
    }
  }
  .progress {
    opacity: 0.1;

    @media (prefers-reduced-motion) {
      opacity: 1;
      transition: none;
    }
    min-width: 8px;
    height: 32px;
    width: 0;
    background: linear-gradient(
      93.78deg,
      rgba(227, 153, 93, 0.25) 8.53%,
      rgba(203, 146, 150, 0.25) 14.9%,
      rgba(127, 72, 214, 0.25) 95.91%
    );

    border-radius: 0 0 20px 0;
    display: inline-block;
    transition: all 0.8s ease-in;
  }
  .value {
    margin-left: $spacing-8;
  }
}
</style>
